
proc InitAthletes { } {

    set structure { 
	{no        "Licence number" 10 p alphanum}
	{firstname "First name" 20 {} alphanum}
	{surname   "Surname" 20 {} alphanum}
        {sex       "Sex" 10 {} alpha}
        {birthday  "Birthday" 4 {} int}
	{club      "Club" 30 {} alphanum}
	{category  "Category" 10 {} alphanum}
    }
    ADB::Init Athletes $structure AthletesDBKey
}

proc AthletesDBKey { rec } {
    return [lindex $rec 0]
}

proc ForAllAthletes { } {
    set atlkey [ADB::FirstKey Athletes]

    while { "$atlkey" != "" } {
        ADB::GetArray Athletes $atlkey athletearr
        
        # Do something with array athletearr, for instance:
        puts "Surname is $athletearr(surname)" 

        set atlkey [ADB::NextKey Athletes]
    }
}

lappend auto_path [file join [pwd] .. src]
package require adb

InitAthletes

ADB::GetEmptyArray Athletes new_arr
set new_arr(no) 12445
set new_arr(firstname) John
set new_arr(surname) Doe
set new_arr(birthday) "01-01-2001"
ADB::Add Athletes [array get new_arr]

puts "Records in table Athletes: [ADB::Count Athletes]"

set licence_no 12445
set rec [ADB::GetRecord Athletes $licence_no]
ADB::RecordToArray Athletes arr $rec
puts "Birthday is $arr(birthday)"

set licence_no 12445
set rec [ADB::GetRecord Athletes $licence_no]
ADB::SetField Athletes club rec "Fortis"
ADB::Change Athletes $rec


proc table_to_listbox { scroll_frame table } {
    listbox $scroll_frame.list

    set i 0
    set objectptr [ADB::FirstKey $table]

    while { $objectptr != "" } {
	$scroll_frame.list insert end [ADB::Textline $table $objectptr]
	incr i
	set objectptr [ADB::NextKey $table] 
    }
    return $scroll_frame.list
}

frame .alist
pack [table_to_listbox .alist Athletes]
pack .alist

